<template>
  <div>
    <b-navbar type="is-dark"  wrapper-class="container">
      <template slot="brand">
        <b-navbar-item tag="router-link" :to="{ path: '/' }">
          <img
            src="mozen_logo_w.png"
            alt="Mozen"
          >
        </b-navbar-item>
      </template>
      <template slot="start" v-if="!isSearch">
        <b-navbar-item tag="div">
          <b-field>
            <b-input placeholder="Search..."
              type="search"
              icon="magnify"
              v-model="search"
              v-on:keyup.enter.native="onSearch"
              >
            </b-input>
          </b-field>
        </b-navbar-item>
      </template>
      <template slot="end">
        <b-navbar-item tag="router-link" :to="{ path: '/' }">
          Home
        </b-navbar-item>
        <b-navbar-item tag="router-link" :to="{ name: 'Search' }">
          Search
        </b-navbar-item>
        <b-navbar-item tag="router-link" :to="{ name: 'Docs' }">
          Docs
        </b-navbar-item>
        <b-navbar-item tag="router-link" :to="{ name: 'About' }">
          <b-icon icon="help-circle-outline"/>
        </b-navbar-item>
        <b-navbar-item tag="div">
          <div v-if="isLogged" class="buttons">
            <b-button tag="router-link" :to="{ name: 'Account' }" type="is-light">
              <strong>Account</strong>
            </b-button>
            <b-button @click="logout" type="is-warning">
              Logout
            </b-button>
          </div>
          <div v-else class="buttons">
            <b-button @click="openRegisterPrompt" type="is-primary">
              <strong>Sign up</strong>
            </b-button>
            <b-button @click="openLoginPrompt" type="is-light">
              Login
            </b-button>
          </div>
        </b-navbar-item>
      </template>
    </b-navbar>

    <b-modal :active.sync="isLoginModalActive" has-modal-card trap-focus aria-role="dialog" aria-modal>
      <LoginForm/>
    </b-modal>

    <b-modal :active.sync="isRegisterModalActive" has-modal-card trap-focus aria-role="dialog" aria-modal>
      <RegisterForm/>
    </b-modal>
  </div>
</template>

<script>
import LoginForm from '@/components/LoginForm.vue'
import RegisterForm from '@/components/RegisterForm.vue'

export default {
  name: 'Navbar',
  components: {
    LoginForm,
    RegisterForm
  },
  data () {
    return {
      isLogged: false,
      isLoginModalActive: false,
      isRegisterModalActive: false,
      search: ''
    }
  },
  computed: {
    isSearch: function () {
      return this.$route.name === 'Search'
    }
  },
  async mounted () {
    const token = await localStorage.getItem('token')
    if (token) this.isLogged = true
  },
  methods: {
    onSearch () {
      this.$router.push({ name: 'Search', query: { n: this.search }, force: true })
    },
    openLoginPrompt () {
      this.isLoginModalActive = true
    },
    openRegisterPrompt () {
      this.isRegisterModalActive = true
    },
    logout () {
      this.isLogged = false
      localStorage.removeItem('token')
      localStorage.removeItem('user_role')
      localStorage.removeItem('user_id')
      this.$router.push({ name: 'Home' })
    }
  }
}
</script>

<style>

</style>
